/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvglcanvas.h
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#ifndef QVGLCANVAS_H
#define QVGLCANVAS_H

#include <QGLWidget>

class QVGLCanvas : public QGLWidget
{
Q_OBJECT

public:
	QVGLCanvas(const QString &title, QWidget* parent);
	~QVGLCanvas ();

	virtual void init() {};
	virtual void display() {};
	virtual void reshape(int w, int h) {};

signals:
	void closed();

protected:
	void initializeGL();
	void paintGL();
	void resizeGL(int w, int h );

	void mousePressEvent(QMouseEvent * event);
	void mouseReleaseEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);
	void wheelEvent(QWheelEvent *event);
	void keyPressEvent(QKeyEvent *event);
	
	void closeEvent(QCloseEvent * event);

	float beginx, beginy;
	float quat[4];
	float zoom;
	bool pressedleft,pressedright;
	float maxwide;
	float cx,cy,cz;
};

#endif
